"""Telegram API 定义。"""
# autogenerated by codegen.py, do not edit manually.
# ruff: noqa: D101, D102, A002
# mypy: ignore-errors
# pylint: disable=redefined-builtin, missing-class-docstring, too-many-locals

from abc import ABC, abstractmethod
from typing import Any, Optional, TypeVar, Union

from .model import (
    BotCommand,
    BotCommandScope,
    BotDescription,
    BotName,
    BotShortDescription,
    BusinessConnection,
    ChatAdministratorRights,
    ChatFullInfo,
    ChatInviteLink,
    ChatMember,
    ChatPermissions,
    File,
    ForceReply,
    ForumTopic,
    GameHighScore,
    InlineKeyboardMarkup,
    InlineQueryResult,
    InlineQueryResultsButton,
    InputFile,
    InputMedia,
    InputMediaAudio,
    InputMediaDocument,
    InputMediaPhoto,
    InputMediaVideo,
    InputPaidMedia,
    InputPollOption,
    InputSticker,
    LabeledPrice,
    LinkPreviewOptions,
    MaskPosition,
    MenuButton,
    Message,
    MessageEntity,
    MessageId,
    PassportElementError,
    Poll,
    ReactionType,
    ReplyKeyboardMarkup,
    ReplyKeyboardRemove,
    ReplyParameters,
    SentWebAppMessage,
    ShippingOption,
    StarTransactions,
    Sticker,
    StickerSet,
    Update,
    User,
    UserChatBoosts,
    UserProfilePhotos,
    WebhookInfo,
)

_T = TypeVar("_T")


class TelegramAPIBase(ABC):
    @abstractmethod
    async def call_api(
        self,
        api: str,
        *,
        response_type: Optional[type[_T]] = None,
        **params: Any,
    ) -> Any: ...


class TelegramAPI(TelegramAPIBase):
    async def get_updates(
        self,
        *,
        offset: Optional[int] = None,
        limit: Optional[int] = None,
        timeout: Optional[int] = None,
        allowed_updates: Optional[list[str]] = None,
    ) -> list[Update]:
        return await self.call_api(
            "getUpdates",
            response_type=list[Update],
            offset=offset,
            limit=limit,
            timeout=timeout,
            allowed_updates=allowed_updates,
        )

    async def set_webhook(
        self,
        *,
        url: str,
        certificate: Optional[InputFile] = None,
        ip_address: Optional[str] = None,
        max_connections: Optional[int] = None,
        allowed_updates: Optional[list[str]] = None,
        drop_pending_updates: Optional[bool] = None,
        secret_token: Optional[str] = None,
    ) -> bool:
        return await self.call_api(
            "setWebhook",
            response_type=bool,
            url=url,
            certificate=certificate,
            ip_address=ip_address,
            max_connections=max_connections,
            allowed_updates=allowed_updates,
            drop_pending_updates=drop_pending_updates,
            secret_token=secret_token,
        )

    async def delete_webhook(
        self, *, drop_pending_updates: Optional[bool] = None
    ) -> bool:
        return await self.call_api(
            "deleteWebhook",
            response_type=bool,
            drop_pending_updates=drop_pending_updates,
        )

    async def get_webhook_info(self) -> WebhookInfo:
        return await self.call_api("getWebhookInfo", response_type=WebhookInfo)

    async def get_me(self) -> User:
        return await self.call_api("getMe", response_type=User)

    async def log_out(self) -> bool:
        return await self.call_api("logOut", response_type=bool)

    async def close(self) -> bool:
        return await self.call_api("close", response_type=bool)

    async def send_message(
        self,
        *,
        chat_id: Union[int, str],
        text: str,
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        parse_mode: Optional[str] = None,
        entities: Optional[list[MessageEntity]] = None,
        link_preview_options: Optional[LinkPreviewOptions] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendMessage",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            text=text,
            parse_mode=parse_mode,
            entities=entities,
            link_preview_options=link_preview_options,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def forward_message(
        self,
        *,
        chat_id: Union[int, str],
        from_chat_id: Union[int, str],
        message_id: int,
        message_thread_id: Optional[int] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
    ) -> Message:
        return await self.call_api(
            "forwardMessage",
            response_type=Message,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            from_chat_id=from_chat_id,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_id=message_id,
        )

    async def forward_messages(
        self,
        *,
        chat_id: Union[int, str],
        from_chat_id: Union[int, str],
        message_ids: list[int],
        message_thread_id: Optional[int] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
    ) -> list[MessageId]:
        return await self.call_api(
            "forwardMessages",
            response_type=list[MessageId],
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            from_chat_id=from_chat_id,
            message_ids=message_ids,
            disable_notification=disable_notification,
            protect_content=protect_content,
        )

    async def copy_message(
        self,
        *,
        chat_id: Union[int, str],
        from_chat_id: Union[int, str],
        message_id: int,
        message_thread_id: Optional[int] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        show_caption_above_media: Optional[bool] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> MessageId:
        return await self.call_api(
            "copyMessage",
            response_type=MessageId,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            from_chat_id=from_chat_id,
            message_id=message_id,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            show_caption_above_media=show_caption_above_media,
            disable_notification=disable_notification,
            protect_content=protect_content,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def copy_messages(
        self,
        *,
        chat_id: Union[int, str],
        from_chat_id: Union[int, str],
        message_ids: list[int],
        message_thread_id: Optional[int] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        remove_caption: Optional[bool] = None,
    ) -> list[MessageId]:
        return await self.call_api(
            "copyMessages",
            response_type=list[MessageId],
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            from_chat_id=from_chat_id,
            message_ids=message_ids,
            disable_notification=disable_notification,
            protect_content=protect_content,
            remove_caption=remove_caption,
        )

    async def send_photo(
        self,
        *,
        chat_id: Union[int, str],
        photo: Union[InputFile, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        show_caption_above_media: Optional[bool] = None,
        has_spoiler: Optional[bool] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendPhoto",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            photo=photo,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            show_caption_above_media=show_caption_above_media,
            has_spoiler=has_spoiler,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_audio(
        self,
        *,
        chat_id: Union[int, str],
        audio: Union[InputFile, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        duration: Optional[int] = None,
        performer: Optional[str] = None,
        title: Optional[str] = None,
        thumbnail: Optional[Union[InputFile, str]] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendAudio",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            audio=audio,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            duration=duration,
            performer=performer,
            title=title,
            thumbnail=thumbnail,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_document(
        self,
        *,
        chat_id: Union[int, str],
        document: Union[InputFile, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        thumbnail: Optional[Union[InputFile, str]] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        disable_content_type_detection: Optional[bool] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendDocument",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            document=document,
            thumbnail=thumbnail,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            disable_content_type_detection=disable_content_type_detection,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_video(
        self,
        *,
        chat_id: Union[int, str],
        video: Union[InputFile, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        duration: Optional[int] = None,
        width: Optional[int] = None,
        height: Optional[int] = None,
        thumbnail: Optional[Union[InputFile, str]] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        show_caption_above_media: Optional[bool] = None,
        has_spoiler: Optional[bool] = None,
        supports_streaming: Optional[bool] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendVideo",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            video=video,
            duration=duration,
            width=width,
            height=height,
            thumbnail=thumbnail,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            show_caption_above_media=show_caption_above_media,
            has_spoiler=has_spoiler,
            supports_streaming=supports_streaming,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_animation(
        self,
        *,
        chat_id: Union[int, str],
        animation: Union[InputFile, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        duration: Optional[int] = None,
        width: Optional[int] = None,
        height: Optional[int] = None,
        thumbnail: Optional[Union[InputFile, str]] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        show_caption_above_media: Optional[bool] = None,
        has_spoiler: Optional[bool] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendAnimation",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            animation=animation,
            duration=duration,
            width=width,
            height=height,
            thumbnail=thumbnail,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            show_caption_above_media=show_caption_above_media,
            has_spoiler=has_spoiler,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_voice(
        self,
        *,
        chat_id: Union[int, str],
        voice: Union[InputFile, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        duration: Optional[int] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendVoice",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            voice=voice,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            duration=duration,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_video_note(
        self,
        *,
        chat_id: Union[int, str],
        video_note: Union[InputFile, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        duration: Optional[int] = None,
        length: Optional[int] = None,
        thumbnail: Optional[Union[InputFile, str]] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendVideoNote",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            video_note=video_note,
            duration=duration,
            length=length,
            thumbnail=thumbnail,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_paid_media(
        self,
        *,
        chat_id: Union[int, str],
        star_count: int,
        media: list[InputPaidMedia],
        business_connection_id: Optional[str] = None,
        payload: Optional[str] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        show_caption_above_media: Optional[bool] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendPaidMedia",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            star_count=star_count,
            media=media,
            payload=payload,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            show_caption_above_media=show_caption_above_media,
            disable_notification=disable_notification,
            protect_content=protect_content,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_media_group(
        self,
        *,
        chat_id: Union[int, str],
        media: Union[
            list[InputMediaAudio],
            list[InputMediaDocument],
            list[InputMediaPhoto],
            list[InputMediaVideo],
        ],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
    ) -> list[Message]:
        return await self.call_api(
            "sendMediaGroup",
            response_type=list[Message],
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            media=media,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
        )

    async def send_location(
        self,
        *,
        chat_id: Union[int, str],
        latitude: float,
        longitude: float,
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        horizontal_accuracy: Optional[float] = None,
        live_period: Optional[int] = None,
        heading: Optional[int] = None,
        proximity_alert_radius: Optional[int] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendLocation",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            latitude=latitude,
            longitude=longitude,
            horizontal_accuracy=horizontal_accuracy,
            live_period=live_period,
            heading=heading,
            proximity_alert_radius=proximity_alert_radius,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_venue(
        self,
        *,
        chat_id: Union[int, str],
        latitude: float,
        longitude: float,
        title: str,
        address: str,
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        foursquare_id: Optional[str] = None,
        foursquare_type: Optional[str] = None,
        google_place_id: Optional[str] = None,
        google_place_type: Optional[str] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendVenue",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            latitude=latitude,
            longitude=longitude,
            title=title,
            address=address,
            foursquare_id=foursquare_id,
            foursquare_type=foursquare_type,
            google_place_id=google_place_id,
            google_place_type=google_place_type,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_contact(
        self,
        *,
        chat_id: Union[int, str],
        phone_number: str,
        first_name: str,
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        last_name: Optional[str] = None,
        vcard: Optional[str] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendContact",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            phone_number=phone_number,
            first_name=first_name,
            last_name=last_name,
            vcard=vcard,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_poll(
        self,
        *,
        chat_id: Union[int, str],
        question: str,
        options: list[InputPollOption],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        question_parse_mode: Optional[str] = None,
        question_entities: Optional[list[MessageEntity]] = None,
        is_anonymous: Optional[bool] = None,
        type: Optional[str] = None,
        allows_multiple_answers: Optional[bool] = None,
        correct_option_id: Optional[int] = None,
        explanation: Optional[str] = None,
        explanation_parse_mode: Optional[str] = None,
        explanation_entities: Optional[list[MessageEntity]] = None,
        open_period: Optional[int] = None,
        close_date: Optional[int] = None,
        is_closed: Optional[bool] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendPoll",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            question=question,
            question_parse_mode=question_parse_mode,
            question_entities=question_entities,
            options=options,
            is_anonymous=is_anonymous,
            type=type,
            allows_multiple_answers=allows_multiple_answers,
            correct_option_id=correct_option_id,
            explanation=explanation,
            explanation_parse_mode=explanation_parse_mode,
            explanation_entities=explanation_entities,
            open_period=open_period,
            close_date=close_date,
            is_closed=is_closed,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_dice(
        self,
        *,
        chat_id: Union[int, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        emoji: Optional[str] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendDice",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            emoji=emoji,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def send_chat_action(
        self,
        *,
        chat_id: Union[int, str],
        action: str,
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
    ) -> bool:
        return await self.call_api(
            "sendChatAction",
            response_type=bool,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            action=action,
        )

    async def set_message_reaction(
        self,
        *,
        chat_id: Union[int, str],
        message_id: int,
        reaction: Optional[list[ReactionType]] = None,
        is_big: Optional[bool] = None,
    ) -> bool:
        return await self.call_api(
            "setMessageReaction",
            response_type=bool,
            chat_id=chat_id,
            message_id=message_id,
            reaction=reaction,
            is_big=is_big,
        )

    async def get_user_profile_photos(
        self, *, user_id: int, offset: Optional[int] = None, limit: Optional[int] = None
    ) -> UserProfilePhotos:
        return await self.call_api(
            "getUserProfilePhotos",
            response_type=UserProfilePhotos,
            user_id=user_id,
            offset=offset,
            limit=limit,
        )

    async def get_file(self, *, file_id: str) -> File:
        return await self.call_api("getFile", response_type=File, file_id=file_id)

    async def ban_chat_member(
        self,
        *,
        chat_id: Union[int, str],
        user_id: int,
        until_date: Optional[int] = None,
        revoke_messages: Optional[bool] = None,
    ) -> bool:
        return await self.call_api(
            "banChatMember",
            response_type=bool,
            chat_id=chat_id,
            user_id=user_id,
            until_date=until_date,
            revoke_messages=revoke_messages,
        )

    async def unban_chat_member(
        self,
        *,
        chat_id: Union[int, str],
        user_id: int,
        only_if_banned: Optional[bool] = None,
    ) -> bool:
        return await self.call_api(
            "unbanChatMember",
            response_type=bool,
            chat_id=chat_id,
            user_id=user_id,
            only_if_banned=only_if_banned,
        )

    async def restrict_chat_member(
        self,
        *,
        chat_id: Union[int, str],
        user_id: int,
        permissions: ChatPermissions,
        use_independent_chat_permissions: Optional[bool] = None,
        until_date: Optional[int] = None,
    ) -> bool:
        return await self.call_api(
            "restrictChatMember",
            response_type=bool,
            chat_id=chat_id,
            user_id=user_id,
            permissions=permissions,
            use_independent_chat_permissions=use_independent_chat_permissions,
            until_date=until_date,
        )

    async def promote_chat_member(
        self,
        *,
        chat_id: Union[int, str],
        user_id: int,
        is_anonymous: Optional[bool] = None,
        can_manage_chat: Optional[bool] = None,
        can_delete_messages: Optional[bool] = None,
        can_manage_video_chats: Optional[bool] = None,
        can_restrict_members: Optional[bool] = None,
        can_promote_members: Optional[bool] = None,
        can_change_info: Optional[bool] = None,
        can_invite_users: Optional[bool] = None,
        can_post_stories: Optional[bool] = None,
        can_edit_stories: Optional[bool] = None,
        can_delete_stories: Optional[bool] = None,
        can_post_messages: Optional[bool] = None,
        can_edit_messages: Optional[bool] = None,
        can_pin_messages: Optional[bool] = None,
        can_manage_topics: Optional[bool] = None,
    ) -> bool:
        return await self.call_api(
            "promoteChatMember",
            response_type=bool,
            chat_id=chat_id,
            user_id=user_id,
            is_anonymous=is_anonymous,
            can_manage_chat=can_manage_chat,
            can_delete_messages=can_delete_messages,
            can_manage_video_chats=can_manage_video_chats,
            can_restrict_members=can_restrict_members,
            can_promote_members=can_promote_members,
            can_change_info=can_change_info,
            can_invite_users=can_invite_users,
            can_post_stories=can_post_stories,
            can_edit_stories=can_edit_stories,
            can_delete_stories=can_delete_stories,
            can_post_messages=can_post_messages,
            can_edit_messages=can_edit_messages,
            can_pin_messages=can_pin_messages,
            can_manage_topics=can_manage_topics,
        )

    async def set_chat_administrator_custom_title(
        self, *, chat_id: Union[int, str], user_id: int, custom_title: str
    ) -> bool:
        return await self.call_api(
            "setChatAdministratorCustomTitle",
            response_type=bool,
            chat_id=chat_id,
            user_id=user_id,
            custom_title=custom_title,
        )

    async def ban_chat_sender_chat(
        self, *, chat_id: Union[int, str], sender_chat_id: int
    ) -> bool:
        return await self.call_api(
            "banChatSenderChat",
            response_type=bool,
            chat_id=chat_id,
            sender_chat_id=sender_chat_id,
        )

    async def unban_chat_sender_chat(
        self, *, chat_id: Union[int, str], sender_chat_id: int
    ) -> bool:
        return await self.call_api(
            "unbanChatSenderChat",
            response_type=bool,
            chat_id=chat_id,
            sender_chat_id=sender_chat_id,
        )

    async def set_chat_permissions(
        self,
        *,
        chat_id: Union[int, str],
        permissions: ChatPermissions,
        use_independent_chat_permissions: Optional[bool] = None,
    ) -> bool:
        return await self.call_api(
            "setChatPermissions",
            response_type=bool,
            chat_id=chat_id,
            permissions=permissions,
            use_independent_chat_permissions=use_independent_chat_permissions,
        )

    async def export_chat_invite_link(self, *, chat_id: Union[int, str]) -> str:
        return await self.call_api(
            "exportChatInviteLink", response_type=str, chat_id=chat_id
        )

    async def create_chat_invite_link(
        self,
        *,
        chat_id: Union[int, str],
        name: Optional[str] = None,
        expire_date: Optional[int] = None,
        member_limit: Optional[int] = None,
        creates_join_request: Optional[bool] = None,
    ) -> ChatInviteLink:
        return await self.call_api(
            "createChatInviteLink",
            response_type=ChatInviteLink,
            chat_id=chat_id,
            name=name,
            expire_date=expire_date,
            member_limit=member_limit,
            creates_join_request=creates_join_request,
        )

    async def edit_chat_invite_link(
        self,
        *,
        chat_id: Union[int, str],
        invite_link: str,
        name: Optional[str] = None,
        expire_date: Optional[int] = None,
        member_limit: Optional[int] = None,
        creates_join_request: Optional[bool] = None,
    ) -> ChatInviteLink:
        return await self.call_api(
            "editChatInviteLink",
            response_type=ChatInviteLink,
            chat_id=chat_id,
            invite_link=invite_link,
            name=name,
            expire_date=expire_date,
            member_limit=member_limit,
            creates_join_request=creates_join_request,
        )

    async def create_chat_subscription_invite_link(
        self,
        *,
        chat_id: Union[int, str],
        subscription_period: int,
        subscription_price: int,
        name: Optional[str] = None,
    ) -> ChatInviteLink:
        return await self.call_api(
            "createChatSubscriptionInviteLink",
            response_type=ChatInviteLink,
            chat_id=chat_id,
            name=name,
            subscription_period=subscription_period,
            subscription_price=subscription_price,
        )

    async def edit_chat_subscription_invite_link(
        self, *, chat_id: Union[int, str], invite_link: str, name: Optional[str] = None
    ) -> ChatInviteLink:
        return await self.call_api(
            "editChatSubscriptionInviteLink",
            response_type=ChatInviteLink,
            chat_id=chat_id,
            invite_link=invite_link,
            name=name,
        )

    async def revoke_chat_invite_link(
        self, *, chat_id: Union[int, str], invite_link: str
    ) -> ChatInviteLink:
        return await self.call_api(
            "revokeChatInviteLink",
            response_type=ChatInviteLink,
            chat_id=chat_id,
            invite_link=invite_link,
        )

    async def approve_chat_join_request(
        self, *, chat_id: Union[int, str], user_id: int
    ) -> bool:
        return await self.call_api(
            "approveChatJoinRequest",
            response_type=bool,
            chat_id=chat_id,
            user_id=user_id,
        )

    async def decline_chat_join_request(
        self, *, chat_id: Union[int, str], user_id: int
    ) -> bool:
        return await self.call_api(
            "declineChatJoinRequest",
            response_type=bool,
            chat_id=chat_id,
            user_id=user_id,
        )

    async def set_chat_photo(
        self, *, chat_id: Union[int, str], photo: InputFile
    ) -> bool:
        return await self.call_api(
            "setChatPhoto", response_type=bool, chat_id=chat_id, photo=photo
        )

    async def delete_chat_photo(self, *, chat_id: Union[int, str]) -> bool:
        return await self.call_api(
            "deleteChatPhoto", response_type=bool, chat_id=chat_id
        )

    async def set_chat_title(self, *, chat_id: Union[int, str], title: str) -> bool:
        return await self.call_api(
            "setChatTitle", response_type=bool, chat_id=chat_id, title=title
        )

    async def set_chat_description(
        self, *, chat_id: Union[int, str], description: Optional[str] = None
    ) -> bool:
        return await self.call_api(
            "setChatDescription",
            response_type=bool,
            chat_id=chat_id,
            description=description,
        )

    async def pin_chat_message(
        self,
        *,
        chat_id: Union[int, str],
        message_id: int,
        business_connection_id: Optional[str] = None,
        disable_notification: Optional[bool] = None,
    ) -> bool:
        return await self.call_api(
            "pinChatMessage",
            response_type=bool,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
            disable_notification=disable_notification,
        )

    async def unpin_chat_message(
        self,
        *,
        chat_id: Union[int, str],
        business_connection_id: Optional[str] = None,
        message_id: Optional[int] = None,
    ) -> bool:
        return await self.call_api(
            "unpinChatMessage",
            response_type=bool,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
        )

    async def unpin_all_chat_messages(self, *, chat_id: Union[int, str]) -> bool:
        return await self.call_api(
            "unpinAllChatMessages", response_type=bool, chat_id=chat_id
        )

    async def leave_chat(self, *, chat_id: Union[int, str]) -> bool:
        return await self.call_api("leaveChat", response_type=bool, chat_id=chat_id)

    async def get_chat(self, *, chat_id: Union[int, str]) -> ChatFullInfo:
        return await self.call_api(
            "getChat", response_type=ChatFullInfo, chat_id=chat_id
        )

    async def get_chat_administrators(
        self, *, chat_id: Union[int, str]
    ) -> list[ChatMember]:
        return await self.call_api(
            "getChatAdministrators", response_type=list[ChatMember], chat_id=chat_id
        )

    async def get_chat_member_count(self, *, chat_id: Union[int, str]) -> int:
        return await self.call_api(
            "getChatMemberCount", response_type=int, chat_id=chat_id
        )

    async def get_chat_member(
        self, *, chat_id: Union[int, str], user_id: int
    ) -> ChatMember:
        return await self.call_api(
            "getChatMember", response_type=ChatMember, chat_id=chat_id, user_id=user_id
        )

    async def set_chat_sticker_set(
        self, *, chat_id: Union[int, str], sticker_set_name: str
    ) -> bool:
        return await self.call_api(
            "setChatStickerSet",
            response_type=bool,
            chat_id=chat_id,
            sticker_set_name=sticker_set_name,
        )

    async def delete_chat_sticker_set(self, *, chat_id: Union[int, str]) -> bool:
        return await self.call_api(
            "deleteChatStickerSet", response_type=bool, chat_id=chat_id
        )

    async def get_forum_topic_icon_stickers(self) -> list[Sticker]:
        return await self.call_api(
            "getForumTopicIconStickers", response_type=list[Sticker]
        )

    async def create_forum_topic(
        self,
        *,
        chat_id: Union[int, str],
        name: str,
        icon_color: Optional[int] = None,
        icon_custom_emoji_id: Optional[str] = None,
    ) -> ForumTopic:
        return await self.call_api(
            "createForumTopic",
            response_type=ForumTopic,
            chat_id=chat_id,
            name=name,
            icon_color=icon_color,
            icon_custom_emoji_id=icon_custom_emoji_id,
        )

    async def edit_forum_topic(
        self,
        *,
        chat_id: Union[int, str],
        message_thread_id: int,
        name: Optional[str] = None,
        icon_custom_emoji_id: Optional[str] = None,
    ) -> bool:
        return await self.call_api(
            "editForumTopic",
            response_type=bool,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            name=name,
            icon_custom_emoji_id=icon_custom_emoji_id,
        )

    async def close_forum_topic(
        self, *, chat_id: Union[int, str], message_thread_id: int
    ) -> bool:
        return await self.call_api(
            "closeForumTopic",
            response_type=bool,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
        )

    async def reopen_forum_topic(
        self, *, chat_id: Union[int, str], message_thread_id: int
    ) -> bool:
        return await self.call_api(
            "reopenForumTopic",
            response_type=bool,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
        )

    async def delete_forum_topic(
        self, *, chat_id: Union[int, str], message_thread_id: int
    ) -> bool:
        return await self.call_api(
            "deleteForumTopic",
            response_type=bool,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
        )

    async def unpin_all_forum_topic_messages(
        self, *, chat_id: Union[int, str], message_thread_id: int
    ) -> bool:
        return await self.call_api(
            "unpinAllForumTopicMessages",
            response_type=bool,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
        )

    async def edit_general_forum_topic(
        self, *, chat_id: Union[int, str], name: str
    ) -> bool:
        return await self.call_api(
            "editGeneralForumTopic", response_type=bool, chat_id=chat_id, name=name
        )

    async def close_general_forum_topic(self, *, chat_id: Union[int, str]) -> bool:
        return await self.call_api(
            "closeGeneralForumTopic", response_type=bool, chat_id=chat_id
        )

    async def reopen_general_forum_topic(self, *, chat_id: Union[int, str]) -> bool:
        return await self.call_api(
            "reopenGeneralForumTopic", response_type=bool, chat_id=chat_id
        )

    async def hide_general_forum_topic(self, *, chat_id: Union[int, str]) -> bool:
        return await self.call_api(
            "hideGeneralForumTopic", response_type=bool, chat_id=chat_id
        )

    async def unhide_general_forum_topic(self, *, chat_id: Union[int, str]) -> bool:
        return await self.call_api(
            "unhideGeneralForumTopic", response_type=bool, chat_id=chat_id
        )

    async def unpin_all_general_forum_topic_messages(
        self, *, chat_id: Union[int, str]
    ) -> bool:
        return await self.call_api(
            "unpinAllGeneralForumTopicMessages", response_type=bool, chat_id=chat_id
        )

    async def answer_callback_query(
        self,
        *,
        callback_query_id: str,
        text: Optional[str] = None,
        show_alert: Optional[bool] = None,
        url: Optional[str] = None,
        cache_time: Optional[int] = None,
    ) -> bool:
        return await self.call_api(
            "answerCallbackQuery",
            response_type=bool,
            callback_query_id=callback_query_id,
            text=text,
            show_alert=show_alert,
            url=url,
            cache_time=cache_time,
        )

    async def get_user_chat_boosts(
        self, *, chat_id: Union[int, str], user_id: int
    ) -> UserChatBoosts:
        return await self.call_api(
            "getUserChatBoosts",
            response_type=UserChatBoosts,
            chat_id=chat_id,
            user_id=user_id,
        )

    async def get_business_connection(
        self, *, business_connection_id: str
    ) -> BusinessConnection:
        return await self.call_api(
            "getBusinessConnection",
            response_type=BusinessConnection,
            business_connection_id=business_connection_id,
        )

    async def set_my_commands(
        self,
        *,
        commands: list[BotCommand],
        scope: Optional[BotCommandScope] = None,
        language_code: Optional[str] = None,
    ) -> bool:
        return await self.call_api(
            "setMyCommands",
            response_type=bool,
            commands=commands,
            scope=scope,
            language_code=language_code,
        )

    async def delete_my_commands(
        self,
        *,
        scope: Optional[BotCommandScope] = None,
        language_code: Optional[str] = None,
    ) -> bool:
        return await self.call_api(
            "deleteMyCommands",
            response_type=bool,
            scope=scope,
            language_code=language_code,
        )

    async def get_my_commands(
        self,
        *,
        scope: Optional[BotCommandScope] = None,
        language_code: Optional[str] = None,
    ) -> list[BotCommand]:
        return await self.call_api(
            "getMyCommands",
            response_type=list[BotCommand],
            scope=scope,
            language_code=language_code,
        )

    async def set_my_name(
        self, *, name: Optional[str] = None, language_code: Optional[str] = None
    ) -> bool:
        return await self.call_api(
            "setMyName", response_type=bool, name=name, language_code=language_code
        )

    async def get_my_name(self, *, language_code: Optional[str] = None) -> BotName:
        return await self.call_api(
            "getMyName", response_type=BotName, language_code=language_code
        )

    async def set_my_description(
        self, *, description: Optional[str] = None, language_code: Optional[str] = None
    ) -> bool:
        return await self.call_api(
            "setMyDescription",
            response_type=bool,
            description=description,
            language_code=language_code,
        )

    async def get_my_description(
        self, *, language_code: Optional[str] = None
    ) -> BotDescription:
        return await self.call_api(
            "getMyDescription",
            response_type=BotDescription,
            language_code=language_code,
        )

    async def set_my_short_description(
        self,
        *,
        short_description: Optional[str] = None,
        language_code: Optional[str] = None,
    ) -> bool:
        return await self.call_api(
            "setMyShortDescription",
            response_type=bool,
            short_description=short_description,
            language_code=language_code,
        )

    async def get_my_short_description(
        self, *, language_code: Optional[str] = None
    ) -> BotShortDescription:
        return await self.call_api(
            "getMyShortDescription",
            response_type=BotShortDescription,
            language_code=language_code,
        )

    async def set_chat_menu_button(
        self, *, chat_id: Optional[int] = None, menu_button: Optional[MenuButton] = None
    ) -> bool:
        return await self.call_api(
            "setChatMenuButton",
            response_type=bool,
            chat_id=chat_id,
            menu_button=menu_button,
        )

    async def get_chat_menu_button(
        self, *, chat_id: Optional[int] = None
    ) -> MenuButton:
        return await self.call_api(
            "getChatMenuButton", response_type=MenuButton, chat_id=chat_id
        )

    async def set_my_default_administrator_rights(
        self,
        *,
        rights: Optional[ChatAdministratorRights] = None,
        for_channels: Optional[bool] = None,
    ) -> bool:
        return await self.call_api(
            "setMyDefaultAdministratorRights",
            response_type=bool,
            rights=rights,
            for_channels=for_channels,
        )

    async def get_my_default_administrator_rights(
        self, *, for_channels: Optional[bool] = None
    ) -> ChatAdministratorRights:
        return await self.call_api(
            "getMyDefaultAdministratorRights",
            response_type=ChatAdministratorRights,
            for_channels=for_channels,
        )

    async def edit_message_text(
        self,
        *,
        text: str,
        business_connection_id: Optional[str] = None,
        chat_id: Optional[Union[int, str]] = None,
        message_id: Optional[int] = None,
        inline_message_id: Optional[str] = None,
        parse_mode: Optional[str] = None,
        entities: Optional[list[MessageEntity]] = None,
        link_preview_options: Optional[LinkPreviewOptions] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Union[Message, bool]:
        return await self.call_api(
            "editMessageText",
            response_type=Union[Message, bool],
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
            inline_message_id=inline_message_id,
            text=text,
            parse_mode=parse_mode,
            entities=entities,
            link_preview_options=link_preview_options,
            reply_markup=reply_markup,
        )

    async def edit_message_caption(
        self,
        *,
        business_connection_id: Optional[str] = None,
        chat_id: Optional[Union[int, str]] = None,
        message_id: Optional[int] = None,
        inline_message_id: Optional[str] = None,
        caption: Optional[str] = None,
        parse_mode: Optional[str] = None,
        caption_entities: Optional[list[MessageEntity]] = None,
        show_caption_above_media: Optional[bool] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Union[Message, bool]:
        return await self.call_api(
            "editMessageCaption",
            response_type=Union[Message, bool],
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
            inline_message_id=inline_message_id,
            caption=caption,
            parse_mode=parse_mode,
            caption_entities=caption_entities,
            show_caption_above_media=show_caption_above_media,
            reply_markup=reply_markup,
        )

    async def edit_message_media(
        self,
        *,
        media: InputMedia,
        business_connection_id: Optional[str] = None,
        chat_id: Optional[Union[int, str]] = None,
        message_id: Optional[int] = None,
        inline_message_id: Optional[str] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Union[Message, bool]:
        return await self.call_api(
            "editMessageMedia",
            response_type=Union[Message, bool],
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
            inline_message_id=inline_message_id,
            media=media,
            reply_markup=reply_markup,
        )

    async def edit_message_live_location(
        self,
        *,
        latitude: float,
        longitude: float,
        business_connection_id: Optional[str] = None,
        chat_id: Optional[Union[int, str]] = None,
        message_id: Optional[int] = None,
        inline_message_id: Optional[str] = None,
        live_period: Optional[int] = None,
        horizontal_accuracy: Optional[float] = None,
        heading: Optional[int] = None,
        proximity_alert_radius: Optional[int] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Union[Message, bool]:
        return await self.call_api(
            "editMessageLiveLocation",
            response_type=Union[Message, bool],
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
            inline_message_id=inline_message_id,
            latitude=latitude,
            longitude=longitude,
            live_period=live_period,
            horizontal_accuracy=horizontal_accuracy,
            heading=heading,
            proximity_alert_radius=proximity_alert_radius,
            reply_markup=reply_markup,
        )

    async def stop_message_live_location(
        self,
        *,
        business_connection_id: Optional[str] = None,
        chat_id: Optional[Union[int, str]] = None,
        message_id: Optional[int] = None,
        inline_message_id: Optional[str] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Union[Message, bool]:
        return await self.call_api(
            "stopMessageLiveLocation",
            response_type=Union[Message, bool],
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
            inline_message_id=inline_message_id,
            reply_markup=reply_markup,
        )

    async def edit_message_reply_markup(
        self,
        *,
        business_connection_id: Optional[str] = None,
        chat_id: Optional[Union[int, str]] = None,
        message_id: Optional[int] = None,
        inline_message_id: Optional[str] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Union[Message, bool]:
        return await self.call_api(
            "editMessageReplyMarkup",
            response_type=Union[Message, bool],
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
            inline_message_id=inline_message_id,
            reply_markup=reply_markup,
        )

    async def stop_poll(
        self,
        *,
        chat_id: Union[int, str],
        message_id: int,
        business_connection_id: Optional[str] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Poll:
        return await self.call_api(
            "stopPoll",
            response_type=Poll,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_id=message_id,
            reply_markup=reply_markup,
        )

    async def delete_message(
        self, *, chat_id: Union[int, str], message_id: int
    ) -> bool:
        return await self.call_api(
            "deleteMessage", response_type=bool, chat_id=chat_id, message_id=message_id
        )

    async def delete_messages(
        self, *, chat_id: Union[int, str], message_ids: list[int]
    ) -> bool:
        return await self.call_api(
            "deleteMessages",
            response_type=bool,
            chat_id=chat_id,
            message_ids=message_ids,
        )

    async def send_sticker(
        self,
        *,
        chat_id: Union[int, str],
        sticker: Union[InputFile, str],
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        emoji: Optional[str] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[
            Union[
                InlineKeyboardMarkup,
                ReplyKeyboardMarkup,
                ReplyKeyboardRemove,
                ForceReply,
            ]
        ] = None,
    ) -> Message:
        return await self.call_api(
            "sendSticker",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            sticker=sticker,
            emoji=emoji,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def get_sticker_set(self, *, name: str) -> StickerSet:
        return await self.call_api("getStickerSet", response_type=StickerSet, name=name)

    async def get_custom_emoji_stickers(
        self, *, custom_emoji_ids: list[str]
    ) -> list[Sticker]:
        return await self.call_api(
            "getCustomEmojiStickers",
            response_type=list[Sticker],
            custom_emoji_ids=custom_emoji_ids,
        )

    async def upload_sticker_file(
        self, *, user_id: int, sticker: InputFile, sticker_format: str
    ) -> File:
        return await self.call_api(
            "uploadStickerFile",
            response_type=File,
            user_id=user_id,
            sticker=sticker,
            sticker_format=sticker_format,
        )

    async def create_new_sticker_set(
        self,
        *,
        user_id: int,
        name: str,
        title: str,
        stickers: list[InputSticker],
        sticker_type: Optional[str] = None,
        needs_repainting: Optional[bool] = None,
    ) -> bool:
        return await self.call_api(
            "createNewStickerSet",
            response_type=bool,
            user_id=user_id,
            name=name,
            title=title,
            stickers=stickers,
            sticker_type=sticker_type,
            needs_repainting=needs_repainting,
        )

    async def add_sticker_to_set(
        self, *, user_id: int, name: str, sticker: InputSticker
    ) -> bool:
        return await self.call_api(
            "addStickerToSet",
            response_type=bool,
            user_id=user_id,
            name=name,
            sticker=sticker,
        )

    async def set_sticker_position_in_set(self, *, sticker: str, position: int) -> bool:
        return await self.call_api(
            "setStickerPositionInSet",
            response_type=bool,
            sticker=sticker,
            position=position,
        )

    async def delete_sticker_from_set(self, *, sticker: str) -> bool:
        return await self.call_api(
            "deleteStickerFromSet", response_type=bool, sticker=sticker
        )

    async def replace_sticker_in_set(
        self, *, user_id: int, name: str, old_sticker: str, sticker: InputSticker
    ) -> bool:
        return await self.call_api(
            "replaceStickerInSet",
            response_type=bool,
            user_id=user_id,
            name=name,
            old_sticker=old_sticker,
            sticker=sticker,
        )

    async def set_sticker_emoji_list(
        self, *, sticker: str, emoji_list: list[str]
    ) -> bool:
        return await self.call_api(
            "setStickerEmojiList",
            response_type=bool,
            sticker=sticker,
            emoji_list=emoji_list,
        )

    async def set_sticker_keywords(
        self, *, sticker: str, keywords: Optional[list[str]] = None
    ) -> bool:
        return await self.call_api(
            "setStickerKeywords", response_type=bool, sticker=sticker, keywords=keywords
        )

    async def set_sticker_mask_position(
        self, *, sticker: str, mask_position: Optional[MaskPosition] = None
    ) -> bool:
        return await self.call_api(
            "setStickerMaskPosition",
            response_type=bool,
            sticker=sticker,
            mask_position=mask_position,
        )

    async def set_sticker_set_title(self, *, name: str, title: str) -> bool:
        return await self.call_api(
            "setStickerSetTitle", response_type=bool, name=name, title=title
        )

    async def set_sticker_set_thumbnail(
        self,
        *,
        name: str,
        user_id: int,
        format: str,
        thumbnail: Optional[Union[InputFile, str]] = None,
    ) -> bool:
        return await self.call_api(
            "setStickerSetThumbnail",
            response_type=bool,
            name=name,
            user_id=user_id,
            thumbnail=thumbnail,
            format=format,
        )

    async def set_custom_emoji_sticker_set_thumbnail(
        self, *, name: str, custom_emoji_id: Optional[str] = None
    ) -> bool:
        return await self.call_api(
            "setCustomEmojiStickerSetThumbnail",
            response_type=bool,
            name=name,
            custom_emoji_id=custom_emoji_id,
        )

    async def delete_sticker_set(self, *, name: str) -> bool:
        return await self.call_api("deleteStickerSet", response_type=bool, name=name)

    async def answer_inline_query(
        self,
        *,
        inline_query_id: str,
        results: list[InlineQueryResult],
        cache_time: Optional[int] = None,
        is_personal: Optional[bool] = None,
        next_offset: Optional[str] = None,
        button: Optional[InlineQueryResultsButton] = None,
    ) -> bool:
        return await self.call_api(
            "answerInlineQuery",
            response_type=bool,
            inline_query_id=inline_query_id,
            results=results,
            cache_time=cache_time,
            is_personal=is_personal,
            next_offset=next_offset,
            button=button,
        )

    async def answer_web_app_query(
        self, *, web_app_query_id: str, result: InlineQueryResult
    ) -> SentWebAppMessage:
        return await self.call_api(
            "answerWebAppQuery",
            response_type=SentWebAppMessage,
            web_app_query_id=web_app_query_id,
            result=result,
        )

    async def send_invoice(
        self,
        *,
        chat_id: Union[int, str],
        title: str,
        description: str,
        payload: str,
        currency: str,
        prices: list[LabeledPrice],
        message_thread_id: Optional[int] = None,
        provider_token: Optional[str] = None,
        max_tip_amount: Optional[int] = None,
        suggested_tip_amounts: Optional[list[int]] = None,
        start_parameter: Optional[str] = None,
        provider_data: Optional[str] = None,
        photo_url: Optional[str] = None,
        photo_size: Optional[int] = None,
        photo_width: Optional[int] = None,
        photo_height: Optional[int] = None,
        need_name: Optional[bool] = None,
        need_phone_number: Optional[bool] = None,
        need_email: Optional[bool] = None,
        need_shipping_address: Optional[bool] = None,
        send_phone_number_to_provider: Optional[bool] = None,
        send_email_to_provider: Optional[bool] = None,
        is_flexible: Optional[bool] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Message:
        return await self.call_api(
            "sendInvoice",
            response_type=Message,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            title=title,
            description=description,
            payload=payload,
            provider_token=provider_token,
            currency=currency,
            prices=prices,
            max_tip_amount=max_tip_amount,
            suggested_tip_amounts=suggested_tip_amounts,
            start_parameter=start_parameter,
            provider_data=provider_data,
            photo_url=photo_url,
            photo_size=photo_size,
            photo_width=photo_width,
            photo_height=photo_height,
            need_name=need_name,
            need_phone_number=need_phone_number,
            need_email=need_email,
            need_shipping_address=need_shipping_address,
            send_phone_number_to_provider=send_phone_number_to_provider,
            send_email_to_provider=send_email_to_provider,
            is_flexible=is_flexible,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def create_invoice_link(
        self,
        *,
        title: str,
        description: str,
        payload: str,
        currency: str,
        prices: list[LabeledPrice],
        provider_token: Optional[str] = None,
        max_tip_amount: Optional[int] = None,
        suggested_tip_amounts: Optional[list[int]] = None,
        provider_data: Optional[str] = None,
        photo_url: Optional[str] = None,
        photo_size: Optional[int] = None,
        photo_width: Optional[int] = None,
        photo_height: Optional[int] = None,
        need_name: Optional[bool] = None,
        need_phone_number: Optional[bool] = None,
        need_email: Optional[bool] = None,
        need_shipping_address: Optional[bool] = None,
        send_phone_number_to_provider: Optional[bool] = None,
        send_email_to_provider: Optional[bool] = None,
        is_flexible: Optional[bool] = None,
    ) -> str:
        return await self.call_api(
            "createInvoiceLink",
            response_type=str,
            title=title,
            description=description,
            payload=payload,
            provider_token=provider_token,
            currency=currency,
            prices=prices,
            max_tip_amount=max_tip_amount,
            suggested_tip_amounts=suggested_tip_amounts,
            provider_data=provider_data,
            photo_url=photo_url,
            photo_size=photo_size,
            photo_width=photo_width,
            photo_height=photo_height,
            need_name=need_name,
            need_phone_number=need_phone_number,
            need_email=need_email,
            need_shipping_address=need_shipping_address,
            send_phone_number_to_provider=send_phone_number_to_provider,
            send_email_to_provider=send_email_to_provider,
            is_flexible=is_flexible,
        )

    async def answer_shipping_query(
        self,
        *,
        shipping_query_id: str,
        ok: bool,
        shipping_options: Optional[list[ShippingOption]] = None,
        error_message: Optional[str] = None,
    ) -> bool:
        return await self.call_api(
            "answerShippingQuery",
            response_type=bool,
            shipping_query_id=shipping_query_id,
            ok=ok,
            shipping_options=shipping_options,
            error_message=error_message,
        )

    async def answer_pre_checkout_query(
        self,
        *,
        pre_checkout_query_id: str,
        ok: bool,
        error_message: Optional[str] = None,
    ) -> bool:
        return await self.call_api(
            "answerPreCheckoutQuery",
            response_type=bool,
            pre_checkout_query_id=pre_checkout_query_id,
            ok=ok,
            error_message=error_message,
        )

    async def get_star_transactions(
        self, *, offset: Optional[int] = None, limit: Optional[int] = None
    ) -> StarTransactions:
        return await self.call_api(
            "getStarTransactions",
            response_type=StarTransactions,
            offset=offset,
            limit=limit,
        )

    async def refund_star_payment(
        self, *, user_id: int, telegram_payment_charge_id: str
    ) -> bool:
        return await self.call_api(
            "refundStarPayment",
            response_type=bool,
            user_id=user_id,
            telegram_payment_charge_id=telegram_payment_charge_id,
        )

    async def set_passport_data_errors(
        self, *, user_id: int, errors: list[PassportElementError]
    ) -> bool:
        return await self.call_api(
            "setPassportDataErrors", response_type=bool, user_id=user_id, errors=errors
        )

    async def send_game(
        self,
        *,
        chat_id: int,
        game_short_name: str,
        business_connection_id: Optional[str] = None,
        message_thread_id: Optional[int] = None,
        disable_notification: Optional[bool] = None,
        protect_content: Optional[bool] = None,
        message_effect_id: Optional[str] = None,
        reply_parameters: Optional[ReplyParameters] = None,
        reply_markup: Optional[InlineKeyboardMarkup] = None,
    ) -> Message:
        return await self.call_api(
            "sendGame",
            response_type=Message,
            business_connection_id=business_connection_id,
            chat_id=chat_id,
            message_thread_id=message_thread_id,
            game_short_name=game_short_name,
            disable_notification=disable_notification,
            protect_content=protect_content,
            message_effect_id=message_effect_id,
            reply_parameters=reply_parameters,
            reply_markup=reply_markup,
        )

    async def set_game_score(
        self,
        *,
        user_id: int,
        score: int,
        force: Optional[bool] = None,
        disable_edit_message: Optional[bool] = None,
        chat_id: Optional[int] = None,
        message_id: Optional[int] = None,
        inline_message_id: Optional[str] = None,
    ) -> Union[Message, bool]:
        return await self.call_api(
            "setGameScore",
            response_type=Union[Message, bool],
            user_id=user_id,
            score=score,
            force=force,
            disable_edit_message=disable_edit_message,
            chat_id=chat_id,
            message_id=message_id,
            inline_message_id=inline_message_id,
        )

    async def get_game_high_scores(
        self,
        *,
        user_id: int,
        chat_id: Optional[int] = None,
        message_id: Optional[int] = None,
        inline_message_id: Optional[str] = None,
    ) -> list[GameHighScore]:
        return await self.call_api(
            "getGameHighScores",
            response_type=list[GameHighScore],
            user_id=user_id,
            chat_id=chat_id,
            message_id=message_id,
            inline_message_id=inline_message_id,
        )
